package com.shixing.edit.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.shixing.edit.R;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;

import java.util.ArrayList;
import java.util.List;

public class BackgroundAdapter extends RecyclerView.Adapter<BackgroundAdapter.TextViewHolder> {
    private Context mContext;
    private List<ActionItem> mActionList;
    private OnActionClickListener mListener;
    private int selectedPosition;
    private String type;
    public BackgroundAdapter(Context mContext, String type) {
        this.mContext = mContext;
        this.type=type;
    }

    public void updateData(List<ActionItem> mTitleList) {
        if (mTitleList == null)
            mTitleList = new ArrayList<>();

        this.mActionList = mTitleList;
        notifyDataSetChanged();
    }

    public void setActionClickListener(OnActionClickListener listener) {
        this.mListener = listener;
    }

    @NonNull
    @Override
    public TextViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        TextViewHolder viewHolder=null;
        switch (type){
            case "color":
                viewHolder= new TextViewHolder(LayoutInflater.from(mContext).inflate(R.layout.item_background_color, parent, false));
                break;
            case "style":
                viewHolder= new TextViewHolder(LayoutInflater.from(mContext).inflate(R.layout.item_background_style, parent, false));
                break;
            case "blurred"://模糊
                viewHolder= new TextViewHolder(LayoutInflater.from(mContext).inflate(R.layout.item_background_blurred, parent, false));
                break;
        }
        return viewHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull final TextViewHolder holder, final int position) {
        if ("color".equals(type)) {
            holder.action_icon.setBackgroundColor(mContext.getResources().getColor(mActionList.get(position).iconResId));
        }else if ("style".equals(type)){
            holder.action_icon.setImageResource(mActionList.get(position).iconResId);
        }else if ("blurred".equals(type)){
            holder.action_icon.setImageResource(mActionList.get(position).iconResId);
        }
        holder.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (mListener != null) {
//                    notifyItemChanged(selectedPosition);
                    selectedPosition = position;
//                    notifyItemChanged(selectedPosition);
                    mListener.onActionClick(mActionList.get(position));
                }
            }
        });
    }

    @Override
    public int getItemCount() {
        return mActionList.size();
    }

    public class TextViewHolder extends RecyclerView.ViewHolder {

        ImageView action_icon;

        public TextViewHolder(View view) {
            super(view);

            action_icon = view.findViewById(R.id.iv_view);

        }

    }


}
