package com.shixing.edit.adjust;


import android.os.Bundle;
import android.view.View;

import com.shixing.edit.EditActivity;
import com.shixing.edit.R;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.filter.FilterFragment;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.sxedit.internal.Effect;
import com.shixing.sxedit.internal.Track;
import com.shixing.sxedit.track.SXTrack;

import java.util.ArrayList;

/*** 剪辑子列表 */
public class AdjustMenu implements OnActionClickListener {

    private  ArrayList<ActionItem> mAdjustActions;
    private EditActivity mActivity;
    private static AdjustMenu instance;
    private  ArrayList<ActionItem> mAdjustThreeActions;
    private AdjustMenu(EditActivity editActivity){
        this.mActivity=editActivity;
    }
    public static AdjustMenu getInstance(EditActivity editActivity){
        if (instance==null)
            instance= new AdjustMenu(editActivity);
        return instance;
    }
    public  ArrayList<ActionItem> getActionList(){
        mAdjustActions = new ArrayList<>();
        mAdjustActions.add(new ActionItem("新增滤镜", R.drawable.icon_lvjing));
        mAdjustActions.add(new ActionItem("新增调节", R.drawable.icon_tiaojie));
        return mAdjustActions;
    }
    public  void showSelectAdjustActionList(){
        mAdjustThreeActions = new ArrayList<>();
        mAdjustThreeActions.add(new ActionItem("调节", R.drawable.icon_tiaojie));
        mAdjustThreeActions.add(new ActionItem("删除", R.drawable.icon_shanchu));
        mActivity.showSubMenu(mAdjustThreeActions,this,"selectAdjust",1);
    }
    public  void onActionClick(ActionItem action) {
        switch (action.iconResId) {
            case R.drawable.icon_lvjing:
                showFilterFragment();
                break;
            case R.drawable.icon_tiaojie:
                showAdjustFragment();
                break;
            case R.drawable.icon_shanchu:
                Effect effect = TrackActionManager.getInstance().getCurrentSelectEffect();
                ActionManager.getInstance().getListener().removeMainTrackEffect(effect);
                TrackActionManager.getInstance().removeEffect(effect);
                TrackActionManager.getInstance().cancelSelectEffectByClick();
                break;
            default:
                break;
        }
    }

    private void showAdjustFragment(){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        AdjustFragment fragment=new AdjustFragment();
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, fragment)
                .commit();
        mActivity.getSupportFragmentManager().beginTransaction().show(fragment);
    }

    public void showAdjustFragmentInPip(Track pipTrack){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        AdjustFragment fragment=new AdjustFragment();
        Bundle bundle=new Bundle();
//        bundle.putSerializable("track",pipTrack);
        fragment.setArguments(bundle);
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, fragment)
                .commit();
        mActivity.getSupportFragmentManager().beginTransaction().show(fragment);
    }
    private void showFilterFragment(){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        Effect effect= TrackActionManager.getInstance().getCurrentSelectEffect();
        FilterFragment transitionFragment=FilterFragment.getInstance(true,null);
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, transitionFragment)
                .commit();
        mActivity.getSupportFragmentManager().beginTransaction().show(transitionFragment);

    }

}
