package com.shixing.edit.audio;


import android.content.Intent;
import android.provider.MediaStore;
import android.view.View;

import androidx.fragment.app.Fragment;

import com.shixing.edit.Constants;
import com.shixing.edit.EditActivity;
import com.shixing.edit.R;
import com.shixing.edit.clip.AudioVolumeFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.sxedit.internal.AudioItem;

import java.util.ArrayList;
import java.util.List;

/*** 剪辑子列表 */
public class AudioMenu implements OnActionClickListener {

    private  ArrayList<ActionItem> mAudioActions;
    private EditActivity mActivity;
    private static AudioMenu instance;
    private AudioMenu(EditActivity editActivity){
        this.mActivity=editActivity;
    }
    public static AudioMenu getInstance(EditActivity editActivity){
        if (instance==null)
            instance= new AudioMenu(editActivity);
        return instance;
    }
    public  ArrayList<ActionItem> getActionList(){
        mAudioActions = new ArrayList<>();
        mAudioActions.add(new ActionItem("添加音乐", R.drawable.icon_yinpin));
        mAudioActions.add(new ActionItem("提取音乐", R.drawable.icon_tiquyinyue));
        mAudioActions.add(new ActionItem("录音", R.drawable.icon_luyin));

        return mAudioActions;
    }

    public  void onActionClick(ActionItem action) {
        switch (action.iconResId) {
            case R.drawable.icon_yinpin:
//                showFragment();
//                String musicPath = Constants.resourcePath+"/audio/music.mp3";
//                AudioItem audioItem = ActionManager.getInstance().getListener().addAudioTrack(musicPath);
//                List<List<AudioItem>> audioGroups = ActionManager.getInstance().getListener().getAudioGroups();
//                TrackActionManager.getInstance().setAudioGroup(audioGroups);
                pickAudio();
                break;
            case R.drawable.icon_tiquyinyue:
                mActivity.extractAudio();
                break;
            case R.drawable.icon_luyin:
                showRecordFragment();
                break;
            default:
                break;
        }

        switch (action.actionName) {
            case "音量":
                showFragment(new AudioVolumeFragment());
                break;
            case "淡化":
                showFragment(new FadInOutFragment());
                break;
            case "分割": {
                AudioItem audioItem = TrackActionManager.getInstance().getCurrentSelectAudio();
                AudioItem newAudio = ActionManager.getInstance().getListener().splitAudio(audioItem);
                if (newAudio != null) {
                    TrackActionManager.getInstance().setAudioGroup(ActionManager.getInstance().getListener().getAudioGroups());
                }
            }
                break;
            case "删除": {
                AudioItem audioItem = TrackActionManager.getInstance().getCurrentSelectAudio();
                ActionManager.getInstance().getListener().removeAudioTrack(audioItem.getAudioId());
                TrackActionManager.getInstance().cancelSelectAudioByClick();
                TrackActionManager.getInstance().setAudioGroup(ActionManager.getInstance().getListener().getAudioGroups());
            }
                break;
            case "变速":
                showFragment(new AudioSpeedFragment());
                break;
            case "复制": {
                AudioItem audioItem = TrackActionManager.getInstance().getCurrentSelectAudio();
                AudioItem newAudio = ActionManager.getInstance().getListener().copyAudioTrack(audioItem);
                if (newAudio != null) {
                    TrackActionManager.getInstance().setAudioGroup(ActionManager.getInstance().getListener().getAudioGroups());
                }
            }
                break;
        }
    }

    private void pickAudio() {
        Intent intent = new Intent(Intent.ACTION_PICK, MediaStore.Audio.Media.EXTERNAL_CONTENT_URI);

        mActivity.startActivityForResult(intent, 9034);
    }

    public void showSelectAudioMenu(){
        ArrayList<ActionItem> mChannelEditActions = new ArrayList<>();
        mChannelEditActions.add(new ActionItem("音量", R.drawable.icon_yinliang));
        mChannelEditActions.add(new ActionItem("淡化", R.drawable.icon_danhua));
        mChannelEditActions.add(new ActionItem("分割", R.drawable.icon_fenge));
        mChannelEditActions.add(new ActionItem("删除", R.drawable.icon_shanchu));
        mChannelEditActions.add(new ActionItem("变速", R.drawable.icon_biansu));
        mChannelEditActions.add(new ActionItem("复制", R.drawable.icon_fuzhi));

        mActivity.showSubMenu(mChannelEditActions,this,"selectAudio",1);
    }

    private void showFragment(){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        MusicFragment transitionFragment=new MusicFragment();
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, transitionFragment)
                .commitNow();
        mActivity.getSupportFragmentManager().beginTransaction().show(transitionFragment);
    }
    private void showRecordFragment(){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        MusicRecordFragment transitionFragment=new MusicRecordFragment();
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, transitionFragment)
                .commitNow();
        mActivity.getSupportFragmentManager().beginTransaction().show(transitionFragment);
    }

    private void showFragment(Fragment fragment){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, fragment)
                .commitNow();
        mActivity.getSupportFragmentManager().beginTransaction().show(fragment);
    }
}
