package com.shixing.edit.audio;

import android.os.Bundle;
import android.view.View;
import android.widget.SeekBar;

import com.shixing.edit.R;
import com.shixing.edit.base.BaseFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.sxedit.internal.AudioItem;
import com.shixing.sxedit.internal.MediaTrack;

public class FadInOutFragment extends BaseFragment implements OnActionClickListener {

    AudioItem audioItem;
    SeekBar seekBarOut;
    SeekBar seekBarIn;
    float volume=1;
    @Override
    protected int initRootView() {
        return R.layout.fragment_fadinout;
    }

    @Override
    protected void initArguments(Bundle arguments) {
       audioItem=TrackActionManager.getInstance().getCurrentSelectAudio();

    }

    @Override
    protected void initView() {
        seekBarOut=mRootView.findViewById(R.id.seekBarOut);
        seekBarIn=mRootView.findViewById(R.id.seekBarIn);
        if (audioItem!=null){
            seekBarIn.setProgress((int)audioItem.getFadeIn()*100/3);
            seekBarOut.setProgress((int)audioItem.getFadeOut()*100/3);
        }
    }

    @Override
    protected void onLazyLoad() {

    }

    @Override
    protected void initListener() {
        mRootView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });
        mRootView.findViewById(R.id.iv_submit).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                TrackActionManager.getInstance().hideDetailFragment();
            }
        });
        seekBarOut.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                float volume=progress*3f/100;
                audioItem.setFadeOut(volume);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        seekBarIn.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                float volume=progress*3f/100;
                audioItem.setFadeIn(volume);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
    }

    @Override
    public void onActionClick(ActionItem action) {

    }


}
