package com.shixing.edit.audio;

import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.shixing.edit.R;
import com.shixing.edit.adapter.MusicAdapter;
import com.shixing.edit.adapter.StickerAdapter;
import com.shixing.edit.adapter.TitleAdapter;
import com.shixing.edit.base.BaseFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;

import java.util.ArrayList;

public class MusicFragment extends BaseFragment<OnActionClickListener> implements OnActionClickListener {

    private RecyclerView mTitle_recycler;
    private RecyclerView mItem1_recycler;
    private ArrayList<String> titleList;
    private ArrayList<ActionItem> itemArrayList;
    private ImageView iv_submit;
    @Override
    protected int initRootView() {
        return R.layout.fragment_sticker;
    }

    @Override
    protected void initArguments(Bundle arguments) {

    }

    @Override
    protected void initView() {
        mTitle_recycler = mRootView.findViewById(R.id.title_recycler);
        mItem1_recycler = mRootView.findViewById(R.id.item1_recycler);
        iv_submit=mRootView.findViewById(R.id.iv_submit);
        titleList = new ArrayList<>();
        titleList.add("收藏");
        titleList.add("综艺");
        titleList.add("笑声");
        titleList.add("BGM");
        titleList.add("收藏");
        titleList.add("综艺");
        titleList.add("笑声");
        titleList.add("BGM");

        TitleAdapter adapter = new TitleAdapter(this.mActivity);
        adapter.updateData(titleList);
        adapter.setActionClickListener(this);
        mTitle_recycler.setAdapter(adapter);
        LinearLayoutManager layoutManager = new LinearLayoutManager(this.mActivity, RecyclerView.HORIZONTAL, false);
        mTitle_recycler.setLayoutManager(layoutManager);
        showItem1("");
    }

    @Override
    protected void onLazyLoad() {

    }

    @Override
    protected void initListener() {
        iv_submit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (listener!=null){
                    ActionItem actionItem=new ActionItem("完成",R.drawable.icon_wancheng);
                    actionItem.id="sticker_selected";
                    listener.onActionClick(actionItem);
                }
            }
        });
        mRootView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });
    }

    @Override
    public void onActionClick(ActionItem action) {
        switch (action.actionType) {
            case ActionItem.text:
                switch (action.actionName) {
                    case "收藏":
                        showItem1("");
                        break;
                    case "综艺":
                        showItem1("");
                        break;
                    case "笑声":
                        showItem1("");
                        break;
                    case "BGM":
                        showItem1("");
                        break;
                    default:
                        break;
                }
                break;

            default:
                break;
        }
    }

    private void showItem1(String srcPath) {
        itemArrayList = new ArrayList<>();

        itemArrayList.add(new ActionItem("贴纸1", srcPath, ActionItem.resId));
        itemArrayList.add(new ActionItem("贴纸1", srcPath, ActionItem.resId));
        itemArrayList.add(new ActionItem("贴纸1", srcPath, ActionItem.resId));
        itemArrayList.add(new ActionItem("贴纸1", srcPath, ActionItem.resId));
        itemArrayList.add(new ActionItem("贴纸1", srcPath, ActionItem.resId));
        itemArrayList.add(new ActionItem("贴纸1", srcPath, ActionItem.resId));
        itemArrayList.add(new ActionItem("贴纸1", srcPath, ActionItem.resId));
        itemArrayList.add(new ActionItem("贴纸1", srcPath, ActionItem.resId));
        itemArrayList.add(new ActionItem("贴纸1", srcPath, ActionItem.resId));
//        itemArrayList.add(new ActionItem("贴纸2", "file:///android_asset/sticker/sticker_2.gif", ActionItem.resId));

        MusicAdapter adapter = new MusicAdapter(this.mActivity);
        adapter.updateData(itemArrayList);
        adapter.setActionClickListener(this);
        mItem1_recycler.setAdapter(adapter);
        LinearLayoutManager layoutManager = new LinearLayoutManager(this.mActivity, RecyclerView.VERTICAL, false);
        mItem1_recycler.setLayoutManager(layoutManager);
    }
}
