package com.shixing.edit.background;


import android.os.Bundle;
import android.view.View;

import androidx.fragment.app.Fragment;

import com.shixing.edit.EditActivity;
import com.shixing.edit.R;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;

import java.util.ArrayList;

/*** 剪辑子列表 */
public class BackgroundMenu implements OnActionClickListener {

    private  ArrayList<ActionItem> mBackgroundActions;
    private EditActivity mActivity;
    private static BackgroundMenu instance;
    private BackgroundMenu(EditActivity editActivity){
        this.mActivity=editActivity;
    }
    public static BackgroundMenu getInstance(EditActivity editActivity){
        if (instance==null)
            instance= new BackgroundMenu(editActivity);
        return instance;
    }
    public  ArrayList<ActionItem> getActionList(){
        mBackgroundActions = new ArrayList<>();
        mBackgroundActions.add(new ActionItem("颜色", R.drawable.icon_huabuyanse));
        mBackgroundActions.add(new ActionItem("样式", R.drawable.icon_huabuyangshi));
//        mBackgroundActions.add(new ActionItem("模糊", R.drawable.icon_muhu));

        return mBackgroundActions;
    }

    public  void onActionClick(ActionItem action) {
        BackgroundFragment fragment=new BackgroundFragment();
        Bundle bundle=new Bundle();
        switch (action.iconResId) {
            case R.drawable.icon_huabuyanse:
                bundle.putString("type","color");
                fragment.setArguments(bundle);
                showFragment(fragment);
                break;
            case R.drawable.icon_huabuyangshi:
                bundle.putString("type","style");
                fragment.setArguments(bundle);
                showFragment(fragment);
                break;
            case R.drawable.icon_muhu:
                bundle.putString("type","blurred");
                fragment.setArguments(bundle);
                showFragment(fragment);
                break;
            default:
                break;
        }
    }

    private void showFragment(Fragment fragment){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, fragment)
                .commit();
        mActivity.getSupportFragmentManager().beginTransaction().show(fragment);
    }
}
