package com.shixing.edit.clip;

import android.os.Bundle;
import android.view.View;
import android.widget.SeekBar;
import android.widget.TextView;

import com.shixing.edit.R;
import com.shixing.edit.base.BaseFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.sxedit.internal.AudioItem;
import com.shixing.sxedit.internal.MediaTrack;

public class AudioVolumeFragment extends BaseFragment implements OnActionClickListener {

    SeekBar seekBar;
    float volume=1;
    private AudioItem audioItem;

    @Override
    protected int initRootView() {
        return R.layout.fragment_volume;
    }

    @Override
    protected void initArguments(Bundle arguments) {
        audioItem = TrackActionManager.getInstance().getCurrentSelectAudio();
    }

    @Override
    protected void initView() {
        seekBar=mRootView.findViewById(R.id.seekBar);
        seekBar.setMax(200);
        seekBar.setProgress((int)(audioItem.getGain()*100));
        ((TextView) findViewById(R.id.tv_seekbar_end)).setText("200");
    }

    @Override
    protected void onLazyLoad() {

    }

    @Override
    protected void initListener() {
        mRootView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });
        mRootView.findViewById(R.id.iv_submit).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                TrackActionManager.getInstance().hideDetailFragment();

            }
        });
        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                volume=progress*1f/100;
                audioItem.setGain(volume);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
    }

    @Override
    public void onActionClick(ActionItem action) {

    }


}
