package com.shixing.edit.clip;

import android.os.Bundle;
import android.view.View;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.SeekBar;

import com.shixing.edit.R;
import com.shixing.edit.base.BaseFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.edit.utils.ToastUtil;
import com.shixing.sxedit.internal.MediaTrack;
import com.shixing.sxedit.internal.Track;

public class ChangeSpeedFragment extends BaseFragment implements OnActionClickListener {

    SeekBar seekBar;
    ImageView iv_submit;
    CheckBox checkbox;
    @Override
    protected int initRootView() {
        return R.layout.fragment_change_speed;
    }

    @Override
    protected void initArguments(Bundle arguments) {

    }
    float origSpeed;
    @Override
    protected void initView() {
        seekBar=mRootView.findViewById(R.id.seekBar);
        iv_submit=mRootView.findViewById(R.id.iv_submit);
        checkbox=mRootView.findViewById(R.id.checkbox);

        Track track = TrackActionManager.getInstance().getCurrentSelectTrack();
        origSpeed= ActionManager.getInstance().getListener().getSpeed((MediaTrack) track);
        seekBar.setProgress(getProgress(origSpeed));

        if (((MediaTrack) track).getPitch() != 1) {
            checkbox.setChecked(true);
        }
    }

    @Override
    protected void onLazyLoad() {

    }

    @Override
    protected void initListener() {
        mRootView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });
        checkbox.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                ToastUtil.showToast(getContext()," 声音变调");
            }
        });
        iv_submit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int progress=seekBar.getProgress();
                double mySpeed=getMySpeed(progress);

                if (TrackActionManager.getInstance().getCurrentSelectTrack()!=null
                        &&TrackActionManager.getInstance().getCurrentSelectTrack() instanceof MediaTrack){
                    MediaTrack track = (MediaTrack) TrackActionManager.getInstance().getCurrentSelectTrack();
                    float speed=ActionManager.getInstance().getListener().changeSpeed(track,(float) mySpeed);
                    if (checkbox.isChecked()) {
                        track.setPitch(speed);
                    } else {
                        track.setPitch(1);
                    }
                    if (origSpeed!=speed){
                        ToastUtil.showToast(getContext()," 变速为"+speed+"倍");
                        TrackActionManager.getInstance().addMainTrack(ActionManager.getInstance().getListener().getMainTracks());
                    }else {
                        ToastUtil.showToast(getContext()," 变速超出边界");
                    }

                }
                TrackActionManager.getInstance().hideDetailFragment();
            }
        });
    }
    //根据变速结果，获得seekbar progress
    private int getProgress(double speed){
        double mySpeed=0.1;
        if (speed<=1){
            mySpeed=speed*1f*20;
        }else if (speed<=2){
            mySpeed=20+(speed-1)*1f*20;
        }else if (speed<=5){
            mySpeed=40+(speed-2)/3f*20;
        }else if (speed<=10){
            mySpeed=60+(speed-5)/5f*20;
        }else if (speed<=100){
            mySpeed=80+(speed-10)/100f*20;
        }
        return (int)mySpeed;
    }

    private double getMySpeed(int progress){
        double mySpeed=0.1;
        if (progress<=20){
            mySpeed=0.1+progress*1f/20;
        }else if (progress<=40){
            mySpeed=1+(progress-20)*1f/20;
        }else if (progress<=60){
            mySpeed=2+(progress-40)*3f/20;
        }else if (progress<=80){
            mySpeed=5+(progress-60)*5f/20;
        }else if (progress<=100){
            mySpeed=10+(progress-80)*100f/20;
        }
        return mySpeed;
    }
    @Override
    public void onActionClick(ActionItem action) {

    }


}
