package com.shixing.edit.clip;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.media.MediaMetadataRetriever;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.SeekBar;
import android.widget.TextView;

import androidx.constraintlayout.widget.ConstraintLayout;

import com.shixing.edit.R;
import com.shixing.edit.base.BaseFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.data.TrackBean;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.edit.multitrack.TrackUtil;
import com.shixing.edit.utils.AppExecutors;
import com.shixing.edit.utils.Logger;
import com.shixing.edit.utils.Utils;
import com.shixing.edit.widget.CropView;
import com.shixing.edit.widget.CustomSeekBar;
import com.shixing.sxedit.internal.MediaTrack;
import com.shixing.sxedit.internal.Track;
import com.yalantis.ucrop.view.GestureCropImageView;
import com.yalantis.ucrop.view.OverlayView;
import com.yalantis.ucrop.view.UCropView;

public class CropFragment extends BaseFragment implements OnActionClickListener, View.OnClickListener {

    CropView cropView;
    ImageView iv_916;
    ImageView iv_34;
    ImageView iv_11;
    ImageView iv_43;
    ImageView iv_169;
    ImageView iv_free;
    TextView tv_916;
    TextView tv_34;
    TextView tv_11;
    TextView tv_43;
    TextView tv_169;
    TextView tv_free;
    LinearLayout ll_916;
    LinearLayout ll_34;
    LinearLayout ll_11;
    LinearLayout ll_43;
    LinearLayout ll_169;
    LinearLayout ll_free;
    TextView currentSelectTv;
    CustomSeekBar customSeekBar;
//    TrackBean trackBean;
    MediaTrack mediaTrack;
    SeekBar seekBar_progress;
    int sourceWidth,sourceHeight;
    Matrix matrix;
    ConstraintLayout cl_progress;
    TextView tv_seekbar_start;
    TextView tv_seekbar_end;


    @Override
    protected int initRootView() {
        return R.layout.fragment_crop;
    }

    @Override
    protected void initArguments(Bundle arguments) {

    }

    @Override
    protected void initView() {
        cropView=mRootView.findViewById(R.id.cropView);
        iv_free=mRootView.findViewById(R.id.iv_free);
        iv_916=mRootView.findViewById(R.id.iv_916);
        iv_34=mRootView.findViewById(R.id.iv_34);
        iv_11=mRootView.findViewById(R.id.iv_11);
        iv_43=mRootView.findViewById(R.id.iv_43);
        iv_169=mRootView.findViewById(R.id.iv_169);
        tv_free=mRootView.findViewById(R.id.tv_free);
        tv_916=mRootView.findViewById(R.id.tv_916);
        tv_34=mRootView.findViewById(R.id.tv_34);
        tv_11=mRootView.findViewById(R.id.tv_11);
        tv_43=mRootView.findViewById(R.id.tv_43);
        tv_169=mRootView.findViewById(R.id.tv_169);
        ll_free=mRootView.findViewById(R.id.ll_free);
        ll_916=mRootView.findViewById(R.id.ll_916);
        ll_34=mRootView.findViewById(R.id.ll_34);
        ll_11=mRootView.findViewById(R.id.ll_11);
        ll_43=mRootView.findViewById(R.id.ll_43);
        ll_169=mRootView.findViewById(R.id.ll_169);
        customSeekBar=mRootView.findViewById(R.id.customSeekBar);
        seekBar_progress=mRootView.findViewById(R.id.seekBar_progress);
        cl_progress=mRootView.findViewById(R.id.cl_progress);
        tv_seekbar_start=mRootView.findViewById(R.id.tv_seekbar_start);
        tv_seekbar_end=mRootView.findViewById(R.id.tv_seekbar_end);

        matrix=new Matrix();


        Bitmap b1;
        if (getArguments()!=null&&getArguments().getSerializable("track")!=null){
            mediaTrack=(MediaTrack)getArguments().getSerializable("track");
            if (mediaTrack.resourceDuration()<=0){
                b1=BitmapFactory.decodeFile(mediaTrack.getFilePath());
                cropView.setImageBitmap(b1);
                sourceWidth=b1.getWidth();
                sourceHeight=b1.getHeight();
                cl_progress.setVisibility(View.GONE);
            }else {
                cl_progress.setVisibility(View.VISIBLE);
                double currentTime=mediaTrack.inPoint();
                getFrameBitmap(currentTime);
                tv_seekbar_start.setText("0");
                tv_seekbar_end.setText((int)mediaTrack.resourceDuration()+"");
            }
        }
        seekBar_progress.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                if (mediaTrack.resourceDuration()>0){
                    getFrameBitmap(mediaTrack.resourceDuration()*progress/100);
                }

            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

        currentSelectTv=tv_free;
        currentSelectTv.setTextColor(getResources().getColor(R.color.text_selected_red));
    }

    private void getFrameBitmap(double time){

        AppExecutors.getInstance().networkIO().execute(new Runnable() {

            @Override
            public void run() {
                MediaMetadataRetriever retriever = new MediaMetadataRetriever();
                retriever.setDataSource(mediaTrack.getFilePath());
                Bitmap tmp = retriever.getFrameAtTime((long) (time * 1000 * 1000));
                cropView.setImageBitmap(tmp);
                sourceWidth=tmp.getWidth();
                sourceHeight=tmp.getHeight();
                retriever.release();
            }
        });
    }
    @Override
    protected void onLazyLoad() {

    }

    @Override
    protected void initListener() {
        ll_free.setOnClickListener(this);
        ll_916.setOnClickListener(this);
        ll_34.setOnClickListener(this);
        ll_11.setOnClickListener(this);
        ll_43.setOnClickListener(this);
        ll_169.setOnClickListener(this);
        mRootView.setOnClickListener(this);
        customSeekBar.setAngleChangeListener(cropView);
        findViewById(R.id.iv_submit).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mediaTrack.cropMediaWithSize(sourceWidth,sourceHeight,cropView.getMatrix());
                ActionManager.getInstance().getListener().updateCurrentFrame();
                TrackActionManager.getInstance().hideDetailFragment();
            }
        });
    }

    @Override
    public void onActionClick(ActionItem action) {

    }

    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.ll_free:
                cropView.setRatio(CropView.Ratio.RATIO_FREE);
                currentSelectTv.setTextColor(getResources().getColor(R.color.white));
                currentSelectTv=tv_free;
                currentSelectTv.setTextColor(getResources().getColor(R.color.text_selected_red));
                break;
            case R.id.ll_916:
                cropView.setRatio(CropView.Ratio.RATIO_916);
                currentSelectTv.setTextColor(getResources().getColor(R.color.white));
                currentSelectTv=tv_916;
                currentSelectTv.setTextColor(getResources().getColor(R.color.text_selected_red));
                break;
            case R.id.ll_34:
                cropView.setRatio(CropView.Ratio.RATIO_34);
                currentSelectTv.setTextColor(getResources().getColor(R.color.white));
                currentSelectTv=tv_34;
                currentSelectTv.setTextColor(getResources().getColor(R.color.text_selected_red));
                break;
            case R.id.ll_11:
                cropView.setRatio(CropView.Ratio.RATIO_11);
                currentSelectTv.setTextColor(getResources().getColor(R.color.white));
                currentSelectTv=tv_11;
                currentSelectTv.setTextColor(getResources().getColor(R.color.text_selected_red));
                break;
            case R.id.ll_43:
                cropView.setRatio(CropView.Ratio.RATIO_43);
                currentSelectTv.setTextColor(getResources().getColor(R.color.white));
                currentSelectTv=tv_43;
                currentSelectTv.setTextColor(getResources().getColor(R.color.text_selected_red));
                break;
            case R.id.ll_169:
                cropView.setRatio(CropView.Ratio.RATIO_169);
                currentSelectTv.setTextColor(getResources().getColor(R.color.white));
                currentSelectTv=tv_169;
                currentSelectTv.setTextColor(getResources().getColor(R.color.text_selected_red));
                break;

        }
    }
}
