package com.shixing.edit.clip;

import android.os.Bundle;
import android.view.View;
import android.widget.SeekBar;

import com.shixing.edit.R;
import com.shixing.edit.base.BaseFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.sxedit.internal.Track;

public class OpacityFragment extends BaseFragment implements OnActionClickListener {


    private SeekBar seekBar;
    private Track currentTrack;

    @Override
    protected int initRootView() {
        return R.layout.fragment_opacity;
    }

    @Override
    protected void initArguments(Bundle arguments) {

    }

    @Override
    protected void initView() {
        seekBar = (SeekBar) findViewById(R.id.seekBar);
        seekBar.setMax(100);

        currentTrack = TrackActionManager.getInstance().getCurrentSelectTrack();
        float opacity = currentTrack.opacity();
        seekBar.setProgress((int) (opacity * 100));
    }

    @Override
    protected void onLazyLoad() {

    }

    @Override
    protected void initListener() {
        mRootView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });

        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                if (fromUser) {
                    ActionManager.getInstance().getListener().setOpacity(currentTrack, progress / 100f);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

        findViewById(R.id.iv_submit).setOnClickListener(v -> TrackActionManager.getInstance().hideDetailFragment());
    }

    @Override
    public void onActionClick(ActionItem action) {

    }


}
