package com.shixing.edit.clip;

import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

import com.shixing.edit.EditActivity;
import com.shixing.edit.R;
import com.shixing.edit.base.BaseFragment;
import com.shixing.edit.manager.ActionListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.sxedit.internal.EditManager;
import com.shixing.sxedit.internal.Track;
import com.shixing.sxedit.internal.TrackGroup;
import com.shixing.sxedit.track.SXTrack;

import java.util.ArrayList;
import java.util.List;

public class PIPLevelFragment extends BaseFragment {

    private TextView mBtn1;
    private TextView mBtn2;
    private TextView mBtn3;
    private TextView mBtn4;
    private TextView mBtn5;
    private TextView mBtn6;
    private List<View> mButtons = new ArrayList<>();
    private Track mTrack;
    private EditManager mEditManager;
    private ActionListener mActionListener;

    private View.OnClickListener mBtnListener = new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            for (View button : mButtons) {
                button.setSelected(v.getId() == button.getId());
            }

            int level = 0;
            switch (v.getId()) {
                case R.id.btn_1:
                    level = 0;
                    break;
                case R.id.btn_2:
                    level = 1;
                    break;
                case R.id.btn_3:
                    level = 2;
                    break;
                case R.id.btn_4:
                    level = 3;
                    break;
                case R.id.btn_5:
                    level = 4;
                    break;
                case R.id.btn_6:
                    level = 5;
                    break;
            }

            TrackGroup group = null;
            for (TrackGroup pipGroup : mActionListener.getPIPGroups()) {
                boolean found = false;
                for (Track track : pipGroup.tracks()) {
                    if (track.equals(mTrack)) {
                        group = pipGroup;
                        found = true;
                        break;
                    }
                }
                if (found)
                    break;
            }

            group.removeTrack(mTrack.getTrackId());
            if (group.tracks().size() == 0) {
                mEditManager.removeGroup(group.getGroupId());
                mActionListener.getPIPGroups().remove(group);
            }

            TrackGroup newGroup = mEditManager.insertNewGroupAt(level);
            newGroup.addTrack(mTrack, mTrack.inPoint());
            mActionListener.getPIPGroups().add(level, newGroup);

            TrackActionManager.getInstance().addTrackGroup(mActionListener.getPIPGroups(), SXTrack.SX_TRACK_TYPE_MEDIA);

            mActionListener.updateCurrentFrame();
        }
    };

    @Override
    protected int initRootView() {
        return R.layout.fragment_pip_level;
    }

    @Override
    protected void initArguments(Bundle arguments) {

    }

    @Override
    protected void initView() {
        mBtn1 = (TextView) findViewById(R.id.btn_1);
        mBtn2 = (TextView) findViewById(R.id.btn_2);
        mBtn3 = (TextView) findViewById(R.id.btn_3);
        mBtn4 = (TextView) findViewById(R.id.btn_4);
        mBtn5 = (TextView) findViewById(R.id.btn_5);
        mBtn6 = (TextView) findViewById(R.id.btn_6);
        mButtons.add(mBtn1);
        mButtons.add(mBtn2);
        mButtons.add(mBtn3);
        mButtons.add(mBtn4);
        mButtons.add(mBtn5);
        mButtons.add(mBtn6);

        for (View button : mButtons) {
            button.setOnClickListener(mBtnListener);
        }
    }

    @Override
    protected void onLazyLoad() {
        mTrack = TrackActionManager.getInstance().getCurrentSelectTrack();

        mActionListener = ActionManager.getInstance().getListener();
        mEditManager = mActionListener.getEditManager();
        int maxLevel = -1;
        int currentLevel = 0;

        boolean foundTrack = false;
        List<TrackGroup> pipGroups = mActionListener.getPIPGroups();
        for (int i = pipGroups.size(); --i >= 0;) {
            TrackGroup pipGroup = pipGroups.get(i);
            List<Track> tracks = pipGroup.tracks();
            if (maxLevel <= 0 && tracks.size() > 0) {
                maxLevel = i + 1;
            }
            for (Track track : tracks) {
                if (track.equals(mTrack)) {
                    foundTrack = true;
                    currentLevel = i;
                    if (tracks.size() > 1) {
                        maxLevel++;
                    }
                    break;
                }
            }
            if (foundTrack)
                break;
        }

        setMaxLevel(maxLevel);
        mButtons.get(currentLevel).setSelected(true);
    }

    @Override
    protected void initListener() {
        findViewById(R.id.iv_submit).setOnClickListener(v -> ((EditActivity) mActivity).hideDetailFragment());
    }

    private void setButtonsEnabled(boolean enabled) {
        for (View button : mButtons) {
            button.setEnabled(enabled);
        }
    }

    private void setMaxLevel(int maxLevel) {
        for (int i = 0; i < mButtons.size(); i++) {
            mButtons.get(i).setVisibility(i < maxLevel ? View.VISIBLE : View.GONE);
        }
    }
}
