package com.shixing.edit.clip;

import android.os.Bundle;
import android.view.View;
import android.widget.SeekBar;
import android.widget.TextView;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.shixing.edit.R;
import com.shixing.edit.adapter.TitleAdapter;
import com.shixing.edit.adapter.TransitionItemAdapter;
import com.shixing.edit.base.BaseFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.sxedit.internal.MediaTrack;

import java.util.ArrayList;

public class VolumeFragment extends BaseFragment implements OnActionClickListener {

    MediaTrack mediaTrack;
    SeekBar seekBar;
    float volume=1;
    @Override
    protected int initRootView() {
        return R.layout.fragment_volume;
    }

    @Override
    protected void initArguments(Bundle arguments) {
        mediaTrack=(MediaTrack) arguments.getSerializable("track");
    }

    @Override
    protected void initView() {
        seekBar=mRootView.findViewById(R.id.seekBar);
        seekBar.setMax(200);
        seekBar.setProgress((int)(mediaTrack.getVolume()*100));
        ((TextView) findViewById(R.id.tv_seekbar_end)).setText(String.valueOf(seekBar.getMax()));
    }

    @Override
    protected void onLazyLoad() {

    }

    @Override
    protected void initListener() {
        mRootView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });
        mRootView.findViewById(R.id.iv_submit).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                TrackActionManager.getInstance().hideDetailFragment();

            }
        });
        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                volume=progress*1f/100;
                mediaTrack.setVolume(volume);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
    }

    @Override
    public void onActionClick(ActionItem action) {

    }


}
