package com.shixing.edit.effects;


import android.os.Bundle;
import android.view.View;

import com.shixing.edit.EditActivity;
import com.shixing.edit.R;
import com.shixing.edit.adapter.ActionAdapter;
import com.shixing.edit.clip.transition.TransitionFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.edit.utils.Logger;
import com.shixing.edit.utils.ToastUtil;
import com.shixing.sxedit.internal.EditManager;
import com.shixing.sxedit.internal.Effect;
import com.shixing.sxedit.internal.Track;
import com.shixing.sxedit.track.SXTrack;

import java.util.ArrayList;

/*** 剪辑子列表 */
public class EffectsMenu implements OnActionClickListener {

    private  ArrayList<ActionItem> mEffectItems;
    private EditActivity mActivity;
    private static EffectsMenu instance;
    private ArrayList<ActionItem> mEffectThreeItmes;;
    private EffectsMenu(EditActivity editActivity){
        this.mActivity=editActivity;
    }
    public static EffectsMenu getInstance(EditActivity editActivity){
        if (instance==null)
            instance= new EffectsMenu(editActivity);
        return instance;
    }
    public  ArrayList<ActionItem> getActionList(){
        mEffectItems = new ArrayList<>();
        mEffectItems.add(new ActionItem("添加特效", R.drawable.icon_texiao));

        return mEffectItems;
    }
    public  void showSelectEffectActionList(){
        mEffectThreeItmes = new ArrayList<>();
        mEffectThreeItmes.add(new ActionItem("特效", R.drawable.icon_texiao));
//        mEffectThreeItmes.add(new ActionItem("复制", R.drawable.icon_fuzhi));
        mEffectThreeItmes.add(new ActionItem("删除", R.drawable.icon_shanchu));
        mActivity.showSubMenu(mEffectThreeItmes,this,"selectEffect",1);
    }

    public  void onActionClick(ActionItem action) {
        Effect effect;
        switch (action.iconResId) {
            case R.drawable.icon_texiao:
                if ("特效".equals(action.actionName)) {
                    //替换特效
                    showFragment();
                } else {
                    //添加新特效
                    double currentTime = ActionManager.getInstance().getListener().getCurrentTime();
                    double duration = ActionManager.getInstance().getListener().getEditManager().editDuration();
                    if (duration - currentTime <= 0.1) {
                        ToastUtil.showToast(mActivity, "当前位置不支持添加");
                        break;
                    }
                    showFragment();
                }
                break;
            case R.drawable.icon_lvjintihuan:
                showFragment();
                break;
            case R.drawable.icon_fuzhi:

                break;
            case R.drawable.icon_shanchu:
                effect = TrackActionManager.getInstance().getCurrentSelectEffect();
                TrackActionManager.getInstance().removeEffect(effect);
                ActionManager.getInstance().getListener().removeMainTrackEffect(effect);
                TrackActionManager.getInstance().cancelSelectEffectByClick();
                break;
            default:
                break;
        }

    }

    private void showFragment(){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        EffectsFragment fragment=new EffectsFragment();
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, fragment)
                .commit();
        mActivity.getSupportFragmentManager().beginTransaction().show(fragment);
    }
    public  void showFragmentInPip(Track pipTrack){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        EffectsFragment fragment=new EffectsFragment();
        Bundle bundle=new Bundle();
//        bundle.putSerializable("track",pipTrack);
        fragment.setArguments(bundle);
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, fragment)
                .commit();
        mActivity.getSupportFragmentManager().beginTransaction().show(fragment);
    }
}
