package com.shixing.edit.filter;


import android.os.Bundle;
import android.view.View;

import com.shixing.edit.EditActivity;
import com.shixing.edit.R;
import com.shixing.edit.adapter.ActionAdapter;
import com.shixing.edit.adjust.AdjustFragment;
import com.shixing.edit.clip.transition.TransitionFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.edit.utils.Logger;
import com.shixing.sxedit.internal.Effect;
import com.shixing.sxedit.internal.FilterEffect;
import com.shixing.sxedit.internal.Track;
import com.shixing.sxedit.track.SXTrack;

import java.util.ArrayList;

/*** 剪辑子列表 */
public class FilterMenu implements OnActionClickListener {

    private  ArrayList<ActionItem> mFilterActions;
    private EditActivity mActivity;
    private static FilterMenu instance;
    private  ArrayList<ActionItem> mFilterThreeActions;
    private FilterMenu(EditActivity editActivity){
        this.mActivity=editActivity;
    }
    public static FilterMenu getInstance(EditActivity editActivity){
        if (instance==null)
            instance= new FilterMenu(editActivity);
        return instance;
    }
    public  ArrayList<ActionItem> getActionList(){
        mFilterActions = new ArrayList<>();
        mFilterActions.add(new ActionItem("新增滤镜", R.drawable.icon_lvjing));
        mFilterActions.add(new ActionItem("新增调节", R.drawable.icon_tiaojie));

        return mFilterActions;
    }
    public  void ShowSelectFilterActionList(){
        mFilterThreeActions = new ArrayList<>();
        mFilterThreeActions.add(new ActionItem("滤镜", R.drawable.icon_lvjing));
        mFilterThreeActions.add(new ActionItem("删除", R.drawable.icon_shanchu));

        mActivity.showSubMenu(mFilterThreeActions,this,"selectFilter",1);
    }
    public  void onActionClick(ActionItem action) {
        switch (action.iconResId) {
            case R.drawable.icon_lvjing:
                showFilterFragment();
                break;
            case R.drawable.icon_tiaojie:
                showAdjustFragment();
                break;
            case R.drawable.icon_shanchu:
                //
                Effect effect = TrackActionManager.getInstance().getCurrentSelectEffect();
                ActionManager.getInstance().getListener().removeMainTrackEffect(effect);
                TrackActionManager.getInstance().removeEffect(effect);
                TrackActionManager.getInstance().cancelSelectEffectByClick();
                break;
            default:
                break;
        }

    }

    private void showFilterFragment(){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        Effect effect=TrackActionManager.getInstance().getCurrentSelectEffect();
        FilterFragment transitionFragment=FilterFragment.getInstance(true,null);
            mActivity.getSupportFragmentManager().beginTransaction()
                    .replace(R.id.menu_container, transitionFragment)
                    .commit();
            mActivity.getSupportFragmentManager().beginTransaction().show(transitionFragment);

    }
    public void showFilterFragmentInPip(Track pipTrack){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        FilterFragment fragment=FilterFragment.getInstance(true,null);
        Bundle bundle=new Bundle();
//        bundle.putSerializable("track",pipTrack);
        fragment.setArguments(bundle);
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, fragment)
                .commit();
        mActivity.getSupportFragmentManager().beginTransaction().show(fragment);
    }
    private void showAdjustFragment(){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        AdjustFragment fragment=new AdjustFragment();
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, fragment)
                .commit();
        mActivity.getSupportFragmentManager().beginTransaction().show(fragment);
    }

}
