package com.shixing.edit.multitrack;

import com.shixing.edit.data.EditData;
import com.shixing.sxedit.internal.AudioItem;
import com.shixing.sxedit.internal.Effect;
import com.shixing.sxedit.internal.Track;

public interface TrackActionListener {

    public void onMovingUp();

    public void onMovingDown();
    /***主轨道触摸滑动，暂停播放**/
    public void onTouchScroll();
    /**当track被手动选中或者取消的时候，对应子菜单UI需要变换
     * @param isSwitch 相同轨道类型内切换为true
     * **/
    public void onTrackSelect(Track track,boolean isSwitch);
    public void onEffectSelect(Effect effect,boolean isSwitch);
    public void onTrackUnSelect(Track track);
    public void onEffectUnSelect(Effect effect);

    /**点击转场方框*/
    public void onClickTransition(Track track);

    public void hideDetailFragment();

    default void onAudioSelect(AudioItem audioItem, boolean isSWitch) {

    }

    default void onAudioUnSelect(AudioItem audioItem) {

    }
}
