package com.shixing.edit.multitrack;

import com.shixing.edit.data.TrackSourceObject;
import com.shixing.sxedit.internal.AudioItem;
import com.shixing.sxedit.internal.Effect;
import com.shixing.sxedit.internal.MediaTrack;
import com.shixing.sxedit.internal.Track;
import com.shixing.sxedit.internal.TrackGroup;

import java.util.List;

public interface TrackViewListener {

    /**更新总时长**/
    public void updateMaxDuration(double duration,boolean isActionUp);
    /**更新轨道缩放尺寸**/
    public void updateScaleSize(float scale);
    public boolean isClicked();//因为都是自定义控件，所以，点击事件出来的时候，需要判断是否点击了真正的有效控件
    public void cancelSelectTrackByClick();
    public void cancelSelectEffectByClick();
    default void cancelSelectAudioByClick() {

    }
//    /**选中或者取消track */
//    public void setTrackSelect(Track trackId,boolean isSelect);
//    public void setMainTrackSelect(Track mainTrackId,boolean isSelect);
//    public void setEffectSelect(Effect effectId,boolean isSelect);
    /**更新track */
    public void updateTrack(Track track);
    public void updateMainTrack(MediaTrack mainTrack);
    public void updateEffect(Effect effect);
    public void updateTrackDuration(Track track);
    public void updateMainTrackDuration(MediaTrack mainTrack);
    public void updateEffectDuration(Effect effect);
    /**删除track**/
    public void removeTrack(Track track);
    public void removeMainTrack(MediaTrack mediaTrack);
    public void removeEffect(Effect effect);
    /**添加track**/
    public void addTrack(Track track);
    /**添加track**/
    public void addMainTrack(List<MediaTrack> mainTracks);
    /**effect**/
    public void addEffect(Effect effect);

    /**添加track**/
    public void addTrackGroup(List<TrackGroup> trackGroups,int trackType);

    public void addEffectList(List<Effect> effectList,int trackType);

    /**添加数据**/
    public void addTrackBeanSource(TrackSourceObject sourceObject);

    void onProgressChanged(double time);
    /**能否添加特效 进行超出层级判断 **/
    boolean canBeAddEffect(Effect effect);

    default void setAudioGroup(List<List<AudioItem>> groups) {
    }

    default void updateTrackAnimation() {
    }

    default void showTrackAnimationMask(boolean show) {
    }

    default void onAudioThumbChanged(String audioId, int[] data) {

    }

    default void onTrackTextChanged(String trackId, String text) {
    }
}
