package com.shixing.edit.ratio;


import android.view.View;

import com.shixing.edit.EditActivity;
import com.shixing.edit.R;
import com.shixing.edit.adapter.ActionAdapter;
import com.shixing.edit.clip.transition.TransitionFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.data.EditData;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.utils.Logger;

import java.util.ArrayList;

/*** 剪辑子列表 */
public class RatioMenu implements OnActionClickListener {

    private  ArrayList<ActionItem> mRatioActions;
    private EditActivity mActivity;
    private static RatioMenu instance;
    private RatioMenu(EditActivity editActivity){
        this.mActivity=editActivity;
    }
    public static RatioMenu getInstance(EditActivity editActivity){
        if (instance==null)
            instance= new RatioMenu(editActivity);
        return instance;
    }
    public  ArrayList<ActionItem> getActionList(){
        mRatioActions = new ArrayList<>();
        mRatioActions.add(new ActionItem("原始", R.drawable.icon_ziyou));
        mRatioActions.add(new ActionItem("9:16", R.drawable.icon_916));
        mRatioActions.add(new ActionItem("3:4", R.drawable.icon_34));
        mRatioActions.add(new ActionItem("1:1", R.drawable.icon_11));
        mRatioActions.add(new ActionItem("4:3", R.drawable.icon_43));
        mRatioActions.add(new ActionItem("16:9", R.drawable.icon_169));

        return mRatioActions;
    }

    public  void onActionClick(ActionItem action) {
        int width = 720;
        int height = 1280;
        switch (action.iconResId) {
            case R.drawable.icon_bianji://转场
                Logger.e("chenfeng","1-----");
                showTransitionFragment();
                break;
            case R.drawable.icon_ziyou:
                break;
            case R.drawable.icon_916:
                break;
            case R.drawable.icon_34:
                width = 768;
                height = 1024;
                break;
            case R.drawable.icon_11:
                width = 800;
                height = 800;
                break;
            case R.drawable.icon_43:
                width = 1024;
                height = 768;
                break;
            case R.drawable.icon_169:
                width = 1280;
                height = 768;
                break;
            default:
                break;
        }
        final int w = width;
        final int h = height;
        mActivity.resetSize(w, h);
    }

    private void showTransitionFragment(){
        mActivity.mMenu_container.setVisibility(View.VISIBLE);
        TransitionFragment transitionFragment=new TransitionFragment();
        mActivity.getSupportFragmentManager().beginTransaction()
                .replace(R.id.menu_container, transitionFragment)
                .commit();
        mActivity.getSupportFragmentManager().beginTransaction().show(transitionFragment);
    }
}
