package com.shixing.edit.sticker;

import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.shixing.edit.Constants;
import com.shixing.edit.R;
import com.shixing.edit.adapter.StickerAdapter;
import com.shixing.edit.adapter.TitleAdapter;
import com.shixing.edit.base.BaseFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.listener.OnFragmentActionListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.edit.utils.ToastUtil;
import com.shixing.sxedit.internal.StickerTrack;
import com.shixing.sxedit.internal.Track;
import com.shixing.sxedit.track.SXTrack;

import java.util.ArrayList;

public class StickerFragment extends BaseFragment<OnActionClickListener> implements OnActionClickListener, OnFragmentActionListener {

    private RecyclerView mTitle_recycler;
    private RecyclerView mItem1_recycler;
    private ArrayList<String> titleList;
    private ArrayList<ActionItem> itemArrayList;
    private ImageView iv_submit;
    private String folderName;

    @Override
    protected int initRootView() {
        return R.layout.fragment_sticker;
    }

    @Override
    protected void initArguments(Bundle arguments) {

    }

    @Override
    protected void initView() {
        mTitle_recycler = mRootView.findViewById(R.id.title_recycler);
        mItem1_recycler = mRootView.findViewById(R.id.item1_recycler);
        iv_submit=mRootView.findViewById(R.id.iv_submit);
        titleList = new ArrayList<>();
        titleList.add("自定义");
//        titleList.add("表情");
//        titleList.add("热门");
//        titleList.add("表情");
//        titleList.add("热门");
//        titleList.add("表情");
//        titleList.add("热门");

        TitleAdapter adapter = new TitleAdapter(this.mActivity);
        adapter.updateData(titleList);
        adapter.setActionClickListener(this);
        mTitle_recycler.setAdapter(adapter);
        LinearLayoutManager layoutManager = new LinearLayoutManager(this.mActivity, RecyclerView.HORIZONTAL, false);
        mTitle_recycler.setLayoutManager(layoutManager);
        showItem1();
    }

    @Override
    protected void onLazyLoad() {

    }

    @Override
    protected void initListener() {
        iv_submit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (listener!=null){
                    ActionItem actionItem=new ActionItem("完成",R.drawable.icon_wancheng);
                    actionItem.id="sticker_selected";
                    listener.onActionClick(actionItem);
                }
            }
        });
        mRootView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });
    }

    @Override
    public void onActionClick(ActionItem action) {
        switch (action.actionType) {
            case ActionItem.text:
                switch (action.actionName) {
                    case "自定义":
                        showItem1();
                        break;
                    case "表情":
                        showItem1();
                        break;
                    case "热门":
                        showItem1();
                        break;
                    default:
                        break;
                }
                break;
//            case "sticker":
//                addSticker(action);
            default:
                addSticker(action);
                break;
        }
    }

    private void addSticker(ActionItem action) {
        String stickerPath = action.actionType;

        StickerTrack track = ActionManager.getInstance().getListener().addStickerTrack(stickerPath);
        if (track != null) {
            ActionManager.getInstance().getListener().updateCurrentFrame();
            TrackActionManager.getInstance().addTrackGroup(ActionManager.getInstance().getListener().getTextStickerGroups(), SXTrack.SX_TRACK_TYPE_TEXT);
            TrackActionManager.getInstance().onTrackSelect(track, false);
        } else {
            ToastUtil.showToast(getContext(), "轨道层级超过限制，添加失败");
        }
    }

    private void showItem1() {
        itemArrayList = new ArrayList<>();

        folderName = "贴纸";
        itemArrayList.add(new ActionItem("贴纸1", Constants.assetsPath + "/" + folderName + "/tz1.gif", Constants.resourcePath + "/" + folderName + "/tz1"));
        itemArrayList.add(new ActionItem("贴纸2", Constants.assetsPath + "/" + folderName + "/tz2.gif", Constants.resourcePath + "/" + folderName + "/tz2"));
        itemArrayList.add(new ActionItem("贴纸3", Constants.assetsPath + "/" + folderName + "/tz3.gif", Constants.resourcePath + "/" + folderName + "/tz3"));
        itemArrayList.add(new ActionItem("贴纸4", Constants.assetsPath + "/" + folderName + "/tz4.gif", Constants.resourcePath + "/" + folderName + "/tz4"));
        itemArrayList.add(new ActionItem("贴纸5", Constants.assetsPath + "/" + folderName + "/tz5.png", Constants.resourcePath + "/" + folderName + "/tz5"));
        itemArrayList.add(new ActionItem("贴纸6", Constants.assetsPath + "/" + folderName + "/tz6.gif", Constants.resourcePath + "/" + folderName + "/tz6"));
        itemArrayList.add(new ActionItem("贴纸7", Constants.assetsPath + "/" + folderName + "/tz7.png", Constants.resourcePath + "/" + folderName + "/tz7"));
        itemArrayList.add(new ActionItem("贴纸8", Constants.assetsPath + "/" + folderName + "/tz8.png", Constants.resourcePath + "/" + folderName + "/tz8"));
        itemArrayList.add(new ActionItem("贴纸9", Constants.assetsPath + "/" + folderName + "/tz9.gif", Constants.resourcePath + "/" + folderName + "/tz9"));
        itemArrayList.add(new ActionItem("贴纸10", Constants.assetsPath + "/" + folderName + "/tz10.gif", Constants.resourcePath + "/" + folderName + "/tz10"));
        itemArrayList.add(new ActionItem("贴纸11", Constants.assetsPath + "/" + folderName + "/tz11.png", Constants.resourcePath + "/" + folderName + "/tz11"));
        itemArrayList.add(new ActionItem("贴纸12", Constants.assetsPath + "/" + folderName + "/tz12.png", Constants.resourcePath + "/" + folderName + "/tz12"));
        itemArrayList.add(new ActionItem("贴纸13", Constants.assetsPath + "/" + folderName + "/tz13.gif", Constants.resourcePath + "/" + folderName + "/tz13"));
        itemArrayList.add(new ActionItem("贴纸14", Constants.assetsPath + "/" + folderName + "/tz14.png", Constants.resourcePath + "/" + folderName + "/tz14"));
        itemArrayList.add(new ActionItem("贴纸15", Constants.assetsPath + "/" + folderName + "/tz15.gif", Constants.resourcePath + "/" + folderName + "/tz15"));
        itemArrayList.add(new ActionItem("贴纸16", Constants.assetsPath + "/" + folderName + "/tz16.gif", Constants.resourcePath + "/" + folderName + "/tz16"));
        itemArrayList.add(new ActionItem("贴纸17", Constants.assetsPath + "/" + folderName + "/tz17.gif", Constants.resourcePath + "/" + folderName + "/tz17"));
        itemArrayList.add(new ActionItem("贴纸18", Constants.assetsPath + "/" + folderName + "/tz18.png", Constants.resourcePath + "/" + folderName + "/tz18"));

        StickerAdapter adapter = new StickerAdapter(this.mActivity);
        adapter.updateData(itemArrayList);
        adapter.setActionClickListener(this);
        mItem1_recycler.setAdapter(adapter);
        GridLayoutManager layoutManager = new GridLayoutManager(this.mActivity, 4);
        mItem1_recycler.setLayoutManager(layoutManager);
    }

    @Override
    public void onTrackSelect(Track track, boolean isSwitch) {
        if (isSwitch){
            switch (track.type()) {
                case SXTrack.SX_TRACK_TYPE_TEXT:
                    break;
                case SXTrack.SX_TRACK_TYPE_STICKER:

                    break;
            }
        }else {
            TrackActionManager.getInstance().hideDetailFragment();
        }

    }

    @Override
    public void onTrackRemove(Track track) {

    }
}
