package com.shixing.edit.sticker;


import android.view.View;

import com.shixing.edit.EditActivity;
import com.shixing.edit.R;
import com.shixing.edit.adapter.ActionAdapter;
import com.shixing.edit.clip.transition.TransitionFragment;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.edit.utils.Logger;
import com.shixing.edit.utils.ToastUtil;
import com.shixing.sxedit.internal.EditManager;
import com.shixing.sxedit.internal.Track;
import com.shixing.sxedit.track.SXTrack;

import java.util.ArrayList;

/*** 剪辑子列表 */
public class StickerMenu implements OnActionClickListener {

    private  ArrayList<ActionItem> mStickerActions;
    private EditActivity mActivity;
    private static StickerMenu instance;
    private StickerMenu(EditActivity editActivity){
        this.mActivity=editActivity;
    }
    public static StickerMenu getInstance(EditActivity editActivity){
        if (instance==null)
            instance= new StickerMenu(editActivity);
        return instance;
    }
    public  ArrayList<ActionItem> getActionList(){
        mStickerActions = new ArrayList<>();
        mStickerActions.add(new ActionItem("添加贴纸", R.drawable.icon_add_tiezhi));
        return mStickerActions;
    }

    public  void showSelectStickerActionList(){
        mStickerActions = new ArrayList<>();
        mStickerActions.add(new ActionItem("镜像", R.drawable.icon_jingxiang));
        mStickerActions.add(new ActionItem("动画", R.drawable.icon_donghua));
        mStickerActions.add(new ActionItem("复制", R.drawable.icon_fuzhi));
        mStickerActions.add(new ActionItem("删除", R.drawable.icon_shanchu));

        mActivity.showSubMenu(mStickerActions,this,"selectSticker",1);
    }

    public  void onActionClick(ActionItem action) {
        switch (action.iconResId) {
            case R.drawable.icon_add_tiezhi://
                showstickerFragment();
                break;
            case R.drawable.icon_jingxiang://
            {
                Track track = TrackActionManager.getInstance().getCurrentSelectTrack();
                ActionManager.getInstance().getListener().horizontalFlip(track);
            }
                break;
            case R.drawable.icon_donghua://
                showAnimationStickerFragment();
                break;
            case R.drawable.icon_fuzhi: {
//                ToastUtil.showToast(mActivity,"复制");
                Track track = TrackActionManager.getInstance().getCurrentSelectTrack();
                Track copyTrack = ActionManager.getInstance().getListener().copyTrack(track);
                if (copyTrack != null) {
                    TrackActionManager.getInstance().addTrackGroup(ActionManager.getInstance().getListener().getTextStickerGroups(), SXTrack.SX_TRACK_TYPE_TEXT);
                    TrackActionManager.getInstance().cancelSelectTrackByClick();
                    ActionManager.getInstance().getListener().updateCurrentFrame(new EditManager.UpdateListener() {
                        @Override
                        public void onUpdateFinish() {
                            TrackActionManager.getInstance().onTrackSelect(copyTrack, false);
                        }
                    });
                } else {
                    ToastUtil.showToast(mActivity, "超过最大层级限制");
                }
            }
                break;
            case R.drawable.icon_shanchu://
//                ToastUtil.showToast(mActivity,"删除");
                Track track = TrackActionManager.getInstance().getCurrentSelectTrack();
                ActionManager.getInstance().getListener().removeTrack(track);
                TrackActionManager.getInstance().addTrackGroup(ActionManager.getInstance().getListener().getTextStickerGroups(), SXTrack.SX_TRACK_TYPE_TEXT);
                TrackActionManager.getInstance().cancelSelectTrackByClick();
                ActionManager.getInstance().getListener().updateCurrentFrame();
                break;
            default:
                break;
        }
    }

    private void showstickerFragment(){
        mActivity.showStickerFragment();
    }

    private void showAnimationStickerFragment(){
        mActivity.showAnimationStickerFragment();
    }
}
