package com.shixing.edit.text;


import com.shixing.edit.EditActivity;
import com.shixing.edit.R;
import com.shixing.edit.data.ActionItem;
import com.shixing.edit.listener.OnActionClickListener;
import com.shixing.edit.manager.ActionManager;
import com.shixing.edit.multitrack.TrackActionManager;
import com.shixing.edit.utils.ToastUtil;
import com.shixing.sxedit.internal.EditManager;
import com.shixing.sxedit.internal.Track;
import com.shixing.sxedit.track.SXTrack;

import java.util.ArrayList;

/*** 剪辑子列表 */
public class TextMenu implements OnActionClickListener {

    private  ArrayList<ActionItem> mTextActions;
    private EditActivity mActivity;
    private ArrayList<ActionItem> mTextEditActions;;
    private static TextMenu instance;
    private TextMenu(EditActivity editActivity){
        this.mActivity=editActivity;
    }
    public static TextMenu getInstance(EditActivity editActivity){
        if (instance==null)
            instance= new TextMenu(editActivity);
        return instance;
    }
    public  ArrayList<ActionItem> getActionList(){
        mTextActions = new ArrayList<>();
        mTextActions.add(new ActionItem("新建文本", R.drawable.icon_xinjianwenben));

        return mTextActions;
    }

    public  void onActionClick(ActionItem action) {
        switch (action.iconResId) {
            case R.drawable.icon_xinjianwenben:
//                showThreeLevelTextMenu();
                if (createNewTextTrack()) {
                    showFragment(0);
                }
                break;
            case R.drawable.icon_yangshi:
                showFragment(1);
                break;
            case R.drawable.icon_qipao:
                showFragment(2);
                break;
            case R.drawable.icon_donghua:
                showFragment(3);
                break;
            case R.drawable.icon_fuzhi: {
                Track track = TrackActionManager.getInstance().getCurrentSelectTrack();
                Track copyTrack = ActionManager.getInstance().getListener().copyTrack(track);
                if (copyTrack != null) {
                    TrackActionManager.getInstance().addTrackGroup(ActionManager.getInstance().getListener().getTextStickerGroups(), SXTrack.SX_TRACK_TYPE_TEXT);
                    TrackActionManager.getInstance().cancelSelectTrackByClick();
                    ActionManager.getInstance().getListener().updateCurrentFrame(new EditManager.UpdateListener() {
                        @Override
                        public void onUpdateFinish() {
                            TrackActionManager.getInstance().onTrackSelect(copyTrack, false);
                        }
                    });
                }
            }
                break;
            case R.drawable.icon_shanchu: {
                Track track = TrackActionManager.getInstance().getCurrentSelectTrack();
                ActionManager.getInstance().getListener().removeTrack(track);
                TrackActionManager.getInstance().addTrackGroup(ActionManager.getInstance().getListener().getTextStickerGroups(), SXTrack.SX_TRACK_TYPE_TEXT);
                TrackActionManager.getInstance().cancelSelectTrackByClick();
                ActionManager.getInstance().getListener().updateCurrentFrame();
            }
                break;
            case R.drawable.icon_fenge:
            {
                Track track = TrackActionManager.getInstance().getCurrentSelectTrack();
                Track newTrack = ActionManager.getInstance().getListener().splitTrack(track);
                TrackActionManager.getInstance().addTrackGroup(ActionManager.getInstance().getListener().getTextStickerGroups(), SXTrack.SX_TRACK_TYPE_TEXT);
                if (newTrack != null) {
                    TrackActionManager.getInstance().onTrackSelect(newTrack, true);
                }
            }
            default:
                break;
        }
    }

    private boolean createNewTextTrack() {
//        EditData.getInstance().createTextTrack();
        Track track= ActionManager.getInstance().getListener().addTextTrack("输入文字");
        if (track != null) {
            ActionManager.getInstance().getListener().updateCurrentFrame();
            TrackActionManager.getInstance().addTrackGroup(ActionManager.getInstance().getListener().getTextStickerGroups(), SXTrack.SX_TRACK_TYPE_TEXT);
            TrackActionManager.getInstance().onTrackSelect(track, false);
            return true;
        } else {
            ToastUtil.showToast(mActivity, "添加失败");
            return false;
        }
    }


    public void showSelectTextTextMenu(){
        ArrayList<ActionItem> mChannelEditActions = new ArrayList<>();
        mChannelEditActions.add(new ActionItem("样式", R.drawable.icon_yangshi));
        mChannelEditActions.add(new ActionItem("气泡", R.drawable.icon_qipao));
        mChannelEditActions.add(new ActionItem("动画", R.drawable.icon_donghua));
        mChannelEditActions.add(new ActionItem("复制", R.drawable.icon_fuzhi));
        mChannelEditActions.add(new ActionItem("删除", R.drawable.icon_shanchu));
        mChannelEditActions.add(new ActionItem("分割", R.drawable.icon_fenge));

        mActivity.showSubMenu(mChannelEditActions,this,"selectText",1);
    }

    private void showFragment(int type){
        mActivity.showTextFragment(type);
    }

}
