package com.shixing.edit.utils;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Point;
import android.view.WindowManager;

public class ScreenUtil {
    public static final ScreenUtil INSTANCE=new ScreenUtil();

    public final Point getScreenSize(Context context) {
        if (context==null){
            return new Point(0,0);
        }
        Point v1 = new Point();
        Object v0 = context.getSystemService("window");
        if(v0 != null) {
            ((WindowManager)v0).getDefaultDisplay().getRealSize(v1);
            return v1;
        }
        return new Point(0,0);
    }
    public final int getScreenHeight(Context context) {
        return this.getScreenSize(context).y;
    }

    public final int getScreenWidth(Context context) {
        return this.getScreenSize(context).x;
    }

    private final float getDensity() {
        Resources v0 = Resources.getSystem();
        return v0.getDisplayMetrics().density;
    }
    private final float getScaledDensity() {
        Resources v0 = Resources.getSystem();
        return v0.getDisplayMetrics().scaledDensity;
    }
    public final int dp2px(float arg18) {
        return (int)(arg18 * this.getDensity() + 0.5f);
    }

    public final float px2dp(int arg18) {
        return  ((float)arg18) / this.getDensity() + 0.5f;
    }

    public final int sp2px(float arg18) {
        return  ((int)(arg18 * this.getScaledDensity() + 0.5f));
    }

}
