package com.shixing.edit.widget;

import android.content.Context;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.VelocityTracker;
import android.view.View;
import android.widget.HorizontalScrollView;

import com.shixing.edit.multitrack.TrackActionManager;

public class TrackScrollView extends HorizontalScrollView  {
    private boolean scrollable = true;
    private View selectedChildView;
    private VelocityTracker mVelocityTracker = null;
    public TrackScrollView(Context context) {
        super(context);
    }

    public TrackScrollView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public TrackScrollView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    public TrackScrollView(Context context, AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
    }


    @Override
    public boolean onTouchEvent(MotionEvent ev) {
        if (mVelocityTracker == null) {
            mVelocityTracker = VelocityTracker.obtain();
        }
        mVelocityTracker.addMovement(ev);
        switch (ev.getAction()){
            case MotionEvent.ACTION_MOVE:
                mVelocityTracker.computeCurrentVelocity(1000);
                if (Math.abs(mVelocityTracker.getXVelocity())>30){
                    TrackActionManager.getInstance().onTouchScroll();
                }
                break;
        }
        if (!scrollable&&selectedChildView!=null){
            selectedChildView.onTouchEvent(ev);
        }
        return scrollable && super.onTouchEvent(ev);
    }

    @Override
    public boolean onInterceptTouchEvent(MotionEvent ev) {
        return scrollable && super.onInterceptTouchEvent(ev);
    }

    public void setScrollingEnabled(boolean enabled) {
        scrollable = enabled;
    }
    //被选中的子view 接受touch事件
    public void setSelectedChildView(View videoView){
        this.selectedChildView=videoView;
    }

}
